/*
Copyright (C) 2006 Evan Teran
                   eteran@alum.rit.edu

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/

#ifndef BINARYINFO_20070718_H_
#define BINARYINFO_20070718_H_

#include "Types.h"
#include <QString>
#include <QList>

class BinaryInfo {
public:
	BinaryInfo(const QString &filename);
	virtual ~BinaryInfo() {}
	
public:
	virtual bool validateHeader() = 0;
	virtual edb::address_t getEntryPoint() = 0;

protected:
	QString m_Filename;
	
public:
	typedef BinaryInfo *(*createFuncPtr)(const QString &);
	typedef QList<createFuncPtr> BinaryInfoList;
	
	static void RegisterBinaryInfo(createFuncPtr fptr);
	static const BinaryInfoList &HandlerList();
	
private:
	static BinaryInfoList &binaryInfoList();
};

#endif

